<?php
require_once 'Interface.php';

class ConfigureTask implements TaskInterface {

    private $_configData = array(
          'DB_HOST' => array( 'q' => 'What is your database host?', 'a' => 'localhost')
        , 'DB_NAME' => array( 'q' => 'What is your database name?', 'a' => 'treetest')
        , 'DB_USER' => array( 'q' => 'What is your database user?', 'a' => 'root')
        , 'DB_PASS' => array( 'q' => 'What is your database user password?', 'a' => '')

        , 'TREE_WEIGHT' => array( 'q' => 'What is your tree weight?', 'a' => 10000)
        , 'TREE_HEIGHT' => array( 'q' => 'What is your tree height?', 'a' => 20)
    );

    public function run() {
        $this->_getUserInput();
        $this->_saveConfig();
    }

    private function _getUserInput() {
        foreach ($this->_configData as $key => $data) {
            if ($key == 'DB_PASS') {
                $a = $this->_getPassword( CLR_WHITE . $data['q'] . CLR_NONE . ' Default [' . CLR_WHITE . $data['a'] . CLR_NONE . ']: ');
            } else {
                echo (preg_match( '/^TREE_/', $key) ? CLR_YELLOW : CLR_WHITE) . $data['q'] . CLR_NONE . ' Default [' . CLR_WHITE . $data['a'] . CLR_NONE . ']: ';
                $a = strtolower( trim( fgets( STDIN)));
            }
            if (!empty( $a)) {
                $this->_configData[$key]['a'] = $a;
            }
        }
    }

    private function _saveConfig() {
        echo CLR_WHITE . "Saving config...\n" . CLR_NONE;
        $config = "<?php\n";
        foreach ($this->_configData as $const => $data) {
            $config .= "define( '$const', " . (is_numeric( $data['a']) ? $data['a'] : "'" . $data['a'] . "'") . ");\n";
        }
        if (!@file_put_contents( 'config/config.php', $config)) {
            echo CLR_LIGHTRED . "ERROR: Cannot save config file! Please, check permissions...\n" . CLR_NONE;
            exit( 0);
        }
        echo CLR_LIGHTGREEN . "Saved!\n" . CLR_NONE;
    }

    private function _getPassword( $prompt) {
        $ostty = `stty -g`;
        system(
            "stty -echo -icanon min 1 time 0 2>/dev/null || " .
            "stty -echo cbreak"
        );
        echo "$prompt";
        $r = substr(fgets(STDIN), 0, -1);
        echo "\n";
        system ("stty $ostty");
        return $r;
    }

}
